力扣HOT100之二分查找:74. 搜索二维矩阵

这道题直接a了,我们可以参考上一道题:35.搜索插入位置的思路,详情见我的上一篇博客。将每一行的第一个元素当作一个数组中的元素,然后对这个数组进行二分查找,如果直接找到了target,则直接返回true,否则退出循环的时候left指向应当插入的下标位置,举几个例子:

1.当输入为

cpp 复制代码
[[1,3,5,7],
 [10,11,16,20],
 [23,30,34,60]]

target为3,则退出循环时left指向元素10所在的位置,此时我们应当去上一层(matrix[left - 1])寻找target。

2.当输入为

cpp 复制代码
[[1,3,5,7],
 [10,11,16,20],
 [23,30,34,60]]

target为61,则退出循环时left的值为3,此时我们应当去上一层(matrix[left - 1],即matrix[2])寻找target。

3.当输入为

cpp 复制代码
[[1,3,5,7],
 [10,11,16,20],
 [23,30,34,60]]

target为0,则退出循环时left的值为0,此时我们无法去上一层(matrix[-1],会发生溢出)寻找target。所以我们需要判断一下退出二分查找后的left是否大于0,只有大于0才进行进一步的搜索,当遍历完整层都没有找到时,返回false,若找到则直接返回true。

cpp 复制代码
class Solution {
public:
    bool searchMatrix(vector<vector<int>>& matrix, int target) {
        int left = 0, right = matrix.size();
        int mid;
        while(left < right){
            mid = (left + right) / 2;
            if(matrix[mid][0] > target)
                right = mid;
            else if(matrix[mid][0] < target)
                left = mid + 1;
            else return true;            
        }
        int i = 0;
        while(left > 0 && i < matrix[0].size()){
            if(matrix[left - 1][i] == target)
                return true;
            i++;
        }
        return false;
    }
};
相关推荐
碧海银沙音频科技研究院2 小时前
基于炬芯ATS3089X自研AEC声学回声消除算法
算法
通问AI2 小时前
在两台 Mac Studio 上跑 800B 模型:MLX + RDMA over Thunderbolt 实测与四道门选型法
算法
ZywOo6232 小时前
《算法竞赛进阶指南》0x03 前缀和与差分
算法
Scintilla_y2 小时前
DAY2 滑动窗口
算法·leetcode·散列表
lvwangshu2 小时前
笛卡尔树
算法·图论
026d233 小时前
状态信号只知“其然”不知“其所以然”:变工况机械故障诊断的物理盲区
算法
姜鱼问生3 小时前
备份和服务器在同一台机器上,等于没备份
算法·架构
姜鱼问生3 小时前
别再 chmod 777 了,用 ACL 给它开一扇窗
后端·算法·架构
特立独行的猫a4 小时前
仓颉语言UI开发实战:我用仓颉写了个桌面版力扣
算法·leetcode·ui·tauri·仓颉·cj-tarui
y1su4 小时前
Leetcode 动态规划 模板
java·数据结构·算法·leetcode·动态规划